﻿/*
	ビデオタイムラインモードでプレイヘッドを1フレーム移動
	移動時にレイヤフォーカスを同方向に移動する
	レイヤフォーカスは現在のレイヤセット（含むビデオグループ）内に限定
*/
#target photoshop
//
//レイヤ操作がブロックされているか否かを返す関数
/*
    これは仮アルゴリズム　もっと良い判定方法を探すこと
    ヒストリに残したくないのでundoをとりこんだほうが良いか
    この判定方法だと、ピクセルのないレイヤ（レイヤセットを含む）、非表示レイヤ、ピクセルロックレイヤなども同列に判定されるのを忘れずに
 ビデオグループ内の移動だと、時間対象外のレイヤで実行すると必ずtrueが出るので一応使えるはず
*/
_isBlocked=function(undoString){
	var targetLayer=app.activeDocument.activeLayer;
	var myExecute="";
/*
 アクションディスクリプタ操作で アルファを保持して50%グレイをオーバーレイで塗りつぶす
 ようするに何もしない操作
 */
myExecute+='var idFl = charIDToTypeID( "Fl  " );';
myExecute+='    var desc3 = new ActionDescriptor();';
myExecute+='    var idUsng = charIDToTypeID( "Usng" );';
myExecute+='    var idFlCn = charIDToTypeID( "FlCn" );';
myExecute+='    var idGry = charIDToTypeID( "Gry " );';
myExecute+='    desc3.putEnumerated( idUsng, idFlCn, idGry );';
myExecute+='    var idOpct = charIDToTypeID( "Opct" );';
myExecute+='    var idPrc = charIDToTypeID( "#Prc" );';
myExecute+='    desc3.putUnitDouble( idOpct, idPrc, 100.000000 );';
myExecute+='    var idMd = charIDToTypeID( "Md  " );';
myExecute+='    var idBlnM = charIDToTypeID( "BlnM" );';
myExecute+='    var idOvrl = charIDToTypeID( "Ovrl" );';
myExecute+='    desc3.putEnumerated( idMd, idBlnM, idOvrl );';
myExecute+='    var idPrsT = charIDToTypeID( "PrsT" );';
myExecute+='    desc3.putBoolean( idPrsT, true );';
myExecute+='executeAction( idFl, desc3, DialogModes.NO );';
		try{
app.activeDocument.suspendHistory( undoString ,"targetLayer.name=targetLayer.name;"); 
app.activeDocument.suspendHistory("checkBlock",myExecute); 
// ===========================チェック操作なのでヒストリの削除
var idDlt = charIDToTypeID( "Dlt " );
    var desc2 = new ActionDescriptor();
    var idnull = charIDToTypeID( "null" );
        var ref1 = new ActionReference();
        var idHstS = charIDToTypeID( "HstS" );
        var idCrnH = charIDToTypeID( "CrnH" );
        ref1.putProperty( idHstS, idCrnH );
    desc2.putReference( idnull, ref1 );
 executeAction( idDlt, desc2, DialogModes.NO );
		}catch(er){return true;}
		return false
}
// =======================================================プレイヘッドを移動
/*
	引数：myWord　previousFrame/nextFrame 前/次
	メニューの移動コマンドと同じ
*/
function movePlayHead(myWord){
var idmoveFrame = stringIDToTypeID( myWord );
    var myDesc = new ActionDescriptor();
    var idtoNextWholeSecond = stringIDToTypeID( "toNextWholeSecond" );
    myDesc.putBoolean( idtoNextWholeSecond, false );
   executeAction( idmoveFrame, myDesc, DialogModes.NO );
}

// ======================================================= timelineGoTo
/*
アクションでメニュー記録した際の抽象化コマンド
これはヘッドが両端でそれ以上の操作を試みるとエラーが出る
 keyWord
	NextFrame
	PreviousFrame
	FirstFrame
	LastFrame
	WorkAreaStart
	WorkAreaEnd
*/
function timelineGoTo(keyWord){
var idslct = charIDToTypeID( "slct" );
    var desc = new ActionDescriptor();
    var idnull = charIDToTypeID( "null" );
        var ref = new ActionReference();
        var idMn = charIDToTypeID( "Mn  " );
        var idMnIt = charIDToTypeID( "MnIt" );
        var idtimelineGoTo = stringIDToTypeID( "timelineGoTo"+keyWord );
        ref.putEnumerated( idMn, idMnIt, idtimelineGoTo );
    desc.putReference( idnull, ref );
executeAction( idslct, desc, DialogModes.NO );
}
// =================================================レイヤフォーカス移動
/*
	Frwrで前面へ　Bckwで後面へ　
	これはデフォルトのショートカットと動作が同じ
*/
function moveFocus(myFocusWord){
var idslct = charIDToTypeID( "slct" );
    var deskFocus = new ActionDescriptor();
    var idnull = charIDToTypeID( "null" );
        var refForcus = new ActionReference();
        var idLyr = charIDToTypeID( "Lyr " );
        var idOrdn = charIDToTypeID( "Ordn" );
        var idWord = charIDToTypeID( myFocusWord );
        refForcus.putEnumerated( idLyr, idOrdn, idWord);
    deskFocus.putReference( idnull, refForcus );
    var idMkVs = charIDToTypeID( "MkVs" );
    deskFocus.putBoolean( idMkVs, false );
executeAction( idslct, deskFocus, DialogModes.NO );
}
// =======================================================レイヤフォーカスをループ移動
/*
	移動後にアクティブレイヤのトレーラーを以前と比較して異なっていたら
	前面移動時はトレーラーの底（最後面）へ
	後面移動時はトレーラーの表（最前面）へ移動…
	ループ先が非表示の場合は、表示されちゃうのでご注意
*/
function loopFocus(myFocusWord){
var myParent=app.activeDocument.activeLayer.parent;//親Trailerを記録
var myLoopTarget=(myFocusWord=="Bckw")? myParent.layers[0]:myParent.layers[myParent.layers.length-1];
	moveFocus(myFocusWord);
//移動後にレイヤトレーラーを判定
  if(myParent !== app.activeDocument.activeLayer.parent){
//     alert("changeTrailer move to :"  + myParent.layers[0].name);
    switch (myFocusWord){
	case "Frwr":
		app.activeDocument.activeLayer=myLoopTarget;
	 	timelineGoTo("FirstFrame");
	break;
	case "Bckw":
		app.activeDocument.activeLayer=myLoopTarget.parent;
		moveFocus("Bckw");
	 	timelineGoTo("LastFrame");
	break;
    }
  }
}
	if($.fileName.indexOf("FocusFwd.jsx")>0){
/*======================================================================
 * 順方向
 *
 */

	movePlayHead("nextFrame");
//	timelineGoTo("NextFrame");
	var blocked=_isBlocked("moveFwd");//カレントがブロック状態か？

 if(blocked){
	loopFocus("Frwr");
// 	timelineGoTo("FirstFrame");
}
	}else{
/*======================================================================
 * 逆方向
 *
 */

	movePlayHead("previousFrame");
//	timelineGoTo("PreviousFrame");
	var blocked=_isBlocked("moveBwd");//カレントがブロック状態か？

 if(blocked){
	loopFocus("Bckw");
// 	timelineGoTo("LastFrame");
}
	}
